/*#################################################################################################
	For		:	Xmega 
	Version	:	1.0
	Date	:	30.07.2013
	Autor	:	Martin Junghans
	Hardware:	ATXmega128A3-U, 32MHz at 16Mhz extern
//################################################################################################*/
#ifndef MACROS_H
#define MACROS_H

#define FALSE	0
#define TRUE	1


//#################################### Macros
#define uniq16(LOW,HEIGHT)	(HEIGHT << 8)|LOW		// 2x 8Bit 	--> 16Bit
#define LOW_BYTE(x)        	(x & 0xff)				// 16Bit 	--> 8Bit
#define HIGH_BYTE(x)       	(x >> 8) & 0xff			// 16Bit 	--> 8Bit


// #define	LOW_BYTE(x)		((uint8_t) (x & 0xff))
// #define	HIGH_BYTE(x)	((uint8_t) (x >> 8))
// #define LOW_WORD(x)		((uint16_t) (x & 0xffff))
// #define HIGH_WORD(x)    ((uint16_t) (x >> 16))


 // uniq32 --> long value = *(long*)&Array[0];
 // uniq32 --> unsigned long value = (unsigned long)byte[0] << 24 | (unsigned long)byte[1] << 16 | (unsigned int) byte[2] <<  8 | byte[3];


#define sbi(ADDRESS,BIT) 	ADDRESS |= (1<<BIT)		// set Bit
#define cbi(ADDRESS,BIT) 	ADDRESS &= ~(1<<BIT)	// clear Bit
#define	toggle(ADDRESS,BIT)	ADDRESS ^= (1<<BIT)		// Bit umschalten

#define	bis(ADDRESS,BIT)	ADDRESS & (1<<BIT)		// bit is set?
#define	bic(ADDRESS,BIT)	!(ADDRESS & (1<<BIT))	// bit is clear?


//####################################
#endif
